using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace TinyNetworkAnalyzer
{
    public partial class Form_GraphOption : Form
    {
        public bool use_gnuplot;
        public bool log_x;
        public string gnuplot_exe_path;

        public Form_GraphOption()
        {
            InitializeComponent();

            // remember from resistry
            Microsoft.Win32.RegistryKey regkey =
                Microsoft.Win32.Registry.CurrentUser.OpenSubKey(@"TinyNetworkAnalyzer\test\sub", false);
            if(regkey != null) {
                Object obj = (string)regkey.GetValue("UseGnuplot");
                if(obj != null) {
                    use_gnuplot = Convert.ToBoolean(obj);
                    checkBox_UseGnuplot.Checked = use_gnuplot;
                }

                obj = (string)regkey.GetValue("GnuplotExePath");
                if(obj != null) {
                    gnuplot_exe_path = (string)obj;
                    textBox_GnuplotPath.Text = gnuplot_exe_path;
                }

                obj = (string)regkey.GetValue("LogX");
                if(obj != null) {
                    log_x = Convert.ToBoolean(obj);
                    checkBox_LogX.Checked = log_x;
                }

                regkey.Close();
            }
        }

        private void checkBox_UseGnuplot_CheckedChanged(object sender, EventArgs e)
        {
            if(((CheckBox)sender).Checked) {
                textBox_GnuplotPath.Enabled = true;
                button_SelectProgram.Enabled = true;
                checkBox_LogX.Enabled = true;
            } else {
                textBox_GnuplotPath.Enabled = false;
                button_SelectProgram.Enabled = false;
                checkBox_LogX.Enabled = false;
            }
        }

        private void button_SelectProgram_Click(object sender, EventArgs e)
        {
            OpenFileDialog ofd = new OpenFileDialog();

            ofd.Filter = "GNUPLOT Executable(*.exe)|*.exe|All Files(*.*)|*.*";
            ofd.FilterIndex = 0;
            ofd.RestoreDirectory = true;
            if (ofd.ShowDialog() == DialogResult.OK) {
                textBox_GnuplotPath.Text = ofd.FileName;
            }
        }

        private void button_Ok_Click(object sender, EventArgs e)
        {
            use_gnuplot = checkBox_UseGnuplot.Checked;
            gnuplot_exe_path = textBox_GnuplotPath.Text;
            log_x = checkBox_LogX.Checked;

            // save to resistry
            Microsoft.Win32.RegistryKey regkey =
                Microsoft.Win32.Registry.CurrentUser.CreateSubKey(@"TinyNetworkAnalyzer\test\sub");
            regkey.SetValue("UseGnuplot", use_gnuplot.ToString());
            regkey.SetValue("GnuplotExePath", gnuplot_exe_path);
            regkey.SetValue("LogX", log_x.ToString());
            regkey.Close();
        }
    }
}