using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace TinyNetworkAnalyzer
{
    public partial class Form_SystemOption : Form
    {
        public bool use_external_clock;
        public double external_clock_frequency = 0.0;

        public Form_SystemOption()
        {
            InitializeComponent();

            // remember from resistry
            Microsoft.Win32.RegistryKey regkey =
                Microsoft.Win32.Registry.CurrentUser.OpenSubKey(@"TinyNetworkAnalyzer\test\sub", false);
            if(regkey != null) {
                Object obj = (string)regkey.GetValue("UseExternalClock");
                if(obj != null) {
                    use_external_clock = Convert.ToBoolean(obj);
                    if(use_external_clock) {
                        radioButton_InternalClock.Checked = false;
                        radioButton_ExternalClock.Checked = true;
                        textBox_Frequency.Enabled = true;
                    } else {
                        radioButton_InternalClock.Checked = true;
                        radioButton_ExternalClock.Checked = false;
                        textBox_Frequency.Enabled = false;
                    }
                }

                obj = (string)regkey.GetValue("ExternalClockFrequency");
                if(obj != null) {
                    external_clock_frequency = Convert.ToDouble(obj);
                    textBox_Frequency.Text = (external_clock_frequency / 1e6).ToString();
                }

                regkey.Close();
            }
        }

        private void radioButton_InternalClock_CheckedChanged(object sender, EventArgs e)
        {
            if(((RadioButton)sender).Checked)
                textBox_Frequency.Enabled = false;
            else
                textBox_Frequency.Enabled = true;
        }

        private void button_Ok_Click(object sender, EventArgs e)
        {
            use_external_clock = radioButton_ExternalClock.Checked;
            if(use_external_clock) {
                try {
                    external_clock_frequency = Convert.ToDouble((string)textBox_Frequency.Text) * 1e6;
                } catch {
                    MessageBox.Show("Invalid frequency value.", "Error");
                    return;
                }
            }

            if(external_clock_frequency == 0.0) {
                MessageBox.Show("Invalid frequency value.", "Error");
                return;
            }

            // save to resistry
            Microsoft.Win32.RegistryKey regkey =
                Microsoft.Win32.Registry.CurrentUser.CreateSubKey(@"TinyNetworkAnalyzer\test\sub");
            regkey.SetValue("UseExternalClock", use_external_clock.ToString());
            regkey.SetValue("ExternalClockFrequency", external_clock_frequency);
            regkey.Close();

            this.DialogResult = DialogResult.OK;
        }
    }
}